
#
# This Program is to
# (1) Build groups in D_n, S_n, A_n
# (2) Calculate Product
# (3) Save the output into a .tex file
#
# by Wieslaw Krawcewicz, Zhichao Li
# on Thursday, April 24, 2014
# at Three Georges University, Yichang, Hubei, China
#

#
# Structure of Program
#
# Declare Constants
# Declare Global Variables
# Declare Functions
# Main Program
#

#
# to run this file, type the following in GAP:
# Read("ProductGroup20140724.gap");
#




Read("GroupProduct_Dabkowski20140727.gap");

Read("GroupProduct_Core20140818.gap");




########## Main Program ##########


Print("\n", "Start of Program.", "\n");


G1 := BuildSymmetricGroup( 4 );
#G1 := BuildAlternatingGroup( 5 );
#G1 := BuildDihedralGroup( 3 );
#G1 := BuildCyclicGroup( 3 );

#G2:=BuildV4Group();
G2 := BuildDihedralGroup( 4 );
#G2 := BuildCyclicGroup( 2 );

G := BuildAmalgaGroup( G1, G2 );


calculate_nLH_number( G );

calculate_multiplication_table( G );

calculate_degrees_of_basic_maps( G );

#
# Syntax:
# create_LaTeX_file ( G, print_multiplication_table, print_basic_degree )
#

create_LaTeX_file( G, "false", "true" );



Print("\n", "End of Program.", "\n");

