# Read("C:/Users/Mietek/Desktop/MietekWieslaw/NewProject/AmalgaNew.gap");




#################### Delete Duplication #######################


Del_Dup:= function (list)

local i, quo;
quo:=[];

for i in [1..Size(list)] do
   if not list[i] in quo then
      Add(quo, list[i]);
   fi;
od;

return quo;

end;




############## IdGroup to Permutation Group #####################

QGroup := function ( Id )

local  quo;

if Id = [  1, 1] then quo:= Group([()]);
elif Id = [  2, 1] then quo:= Group([(1,2)]);
elif Id = [  3, 1] then quo:= Group([(1,2,3)]);
elif Id = [  4, 1] then quo:= Group([(1,2,3,4)]);
elif Id = [  4, 2] then quo:= Group([(1,2),(3,4)]);
elif Id = [  6, 2] then quo:= Group([(1,2,3,4,5,6)]);
elif Id = [  6, 1] then quo:= Group([(1,2,3),(2,3)]);
elif Id = [  8, 3] then quo:= Group([(1,2,3,4),(2,4)]);
elif Id = [ 10, 1] then quo:= Group([(1,2,3,4,5),(2,5)(3,4)]);
elif Id = [ 12, 4] then quo:= Group([(1,2,3,4,5,6),(2,6)(3,5)]);
elif Id = [ 14, 1] then quo:= Group([(1,2,3,4,5,6,7),(2,7)(3,6)(4,5)]);
elif Id = [ 16, 7] then quo:= Group([(1,2,3,4,5,6,7,8),(2,8)(3,7)(4,6)]);
elif Id = [ 18, 1] then quo:= Group([(1,2,3,4,5,6,7,8,9),(2,9)(3,8)(4,7)(5,6)]);
elif Id = [ 20, 4] then quo:= Group([(1,2,3,4,5,6,7,8,9,10),(2,10)(3,9)(4,8)(5,7)]);
elif Id = [ 12, 3] then quo:= AlternatingGroup(4);
elif Id = [ 60, 5] then quo:= AlternatingGroup(5);
elif Id = [ 24,12] then quo:= SymmetricGroup(4);
elif Id = [120,34] then quo:= SymmetricGroup(5);
else quo:= SmallGroup(Id);
fi;


return quo;

end;






############## Find all Quotient Subgroups in Id ################


Find_Quo:= function(g)

local i, j, k, quo_list, ccs;

ccs:=ConjugacyClassesSubgroups(g);
i:= Size(ccs);
quo_list:=[];

while i>1 do
   for j in [1..i-1] do
		for k in [1..Size(ccs[i])] do
			if IsNormal(ccs[i][k],ccs[j][1]) and
            IsSubgroup(ccs[i][k],ccs[j][1]) then
				Add(quo_list, IdGroup(ccs[i][k]/ccs[j][1]));
			fi;
		od;
	od;
	i:=i-1;
od;

Add(quo_list, [1,1]);

quo_list:= Del_Dup(quo_list);

for i in [1..Size(quo_list)] do
   quo_list[i]:= QGroup(quo_list[i]);
od;

return quo_list;

end;


#################### Find Intersection #########################


Inter_Quo:=function(g,h)

local gquo_list, hquo_list, gquo, hquo,
      inter, quo, i, j, k;

gquo_list:=Find_Quo(g);
hquo_list:=Find_Quo(h);

for i in [1..Size(gquo_list)] do
   gquo_list[i]:= IdGroup(gquo_list[i]);
od;

for j in [1..Size(hquo_list)] do
   hquo_list[j]:= IdGroup(hquo_list[j]);
od;

inter:=Intersection(gquo_list, hquo_list);

for k in [1..Size(inter)] do
   inter[k]:= QGroup(inter[k]);
od;

return inter;

end;




############ Q Symbol  ###################
############Added by Wieslaw and Leaf##############
############Thursday, July 24, 2014 in Yichang, Hubei, China #######

QSymbol := function ( GroupSymbol )

# Example: QSymbol ( [ 3,1] ) = \mathbb Z_3


local  i, j;

	#if GroupSymbol = [   1, 1] then return "{\\mathbb{Z}_{1}}"; fi;
	if GroupSymbol = [   1, 1] then return "{}"; fi;
	if GroupSymbol = [   2, 1] then return "{\\mathbb{Z}_{2}}"; fi;
	if GroupSymbol = [   3, 1] then return "{\\mathbb{Z}_{3}}"; fi;
        if GroupSymbol = [   3, 1] then return "{\\mathbb{Z}_{3}}"; fi;
	if GroupSymbol = [   4, 1] then return "{\\mathbb {Z}_{4}}"; fi;
	if GroupSymbol = [   5, 1] then return "{\\mathbb {Z}_{5}}"; fi;
	if GroupSymbol = [   6, 2] then return "{\\mathbb {Z}_{6}}"; fi;
	if GroupSymbol = [   7, 1] then return "{\\mathbb {Z}_{7}}"; fi;
	if GroupSymbol = [   8, 1] then return "{\\mathbb {Z}_{8}}"; fi;
	if GroupSymbol = [   9, 1] then return "{\\mathbb {Z}_{9}}"; fi;
	if GroupSymbol = [   10, 2] then return "{\\mathbb {Z}_{10}}"; fi;
	if GroupSymbol = [   4, 2] then return "{V_{4}}"; fi;
	if GroupSymbol = [   6, 1] then return "{D_{3}}"; fi;
	if GroupSymbol = [   8, 3] then return "{D_{4}}"; fi;
	if GroupSymbol = [ 10, 1] then return "{D_{5}}"; fi;
	if GroupSymbol = [ 12, 4] then return "{D_{6}}"; fi;
	if GroupSymbol = [ 14, 1] then return "{D_{7}}"; fi;
	if GroupSymbol = [ 16, 7] then return "{D_{8}}"; fi;
	if GroupSymbol = [ 18, 1] then return "{D_{9}}"; fi;
	if GroupSymbol = [ 20, 4] then return "{D_{10}}"; fi;
	if GroupSymbol = [ 20, 3] then return "F_{20}"; fi;
	if GroupSymbol = [ 12, 3] then return "{A_{4}}"; fi;
	if GroupSymbol = [ 60, 5] then return "{A_{5}}"; fi;
	if GroupSymbol = [ 24,12] then return "{S_{4}}"; fi;
	if GroupSymbol = [120,34] then return "{S_{5}}"; fi;

	return GroupSymbol;

end;





############ H Symbol  ###################
############Added by Wieslaw and Leaf##############
############Thursday, July 24, 2014 in Yichang, Hubei, China #######

HSymbol := function ( G, subG )


local  i, j;

	j := Order( subG );

	for i in G.ccsl do
		if i.order <> j then
			continue;
		fi;

		if IsConjugate( G.group, i.representative, subG ) then
			return i.LaTeXName;
		fi;
	od;

	return "";

end;




####### Generate Tuple [[H, hom1*auto], [K, hom2*auto]] ########

# Gen_Tup:=function(subg, subh, quo)

# updated by Leaf on Thursday, July 24th, 2014 in Yichang, Hubei, China
Gen_Tup:=function(G, subg, H, subh, quo)

local q, list, hom1, hom2, auto,
	Embed1, Embed2,
	hom11, hom22,
	Generator_List,
	h1, h2, k1, k2, element1, element2, 
	 i, j, k, l, m, n, o, p,  r, s, t, u, v, w, x, y, z;

#q:=SmallGroup(quo);
hom1:=GQuotients(subg, quo);
hom2:=GQuotients(subh, quo);
auto:=List(AutomorphismGroup(quo));
list:=[];
#
#Print("\n Size(hom1) = ", Size(hom1), "\n");
#
#Print("\n hom1 = ", hom1, "\n");
#
#Print("\n Size(hom2) = ", Size(hom2), "\n");
##
#Print("\n hom2 = ", hom2, "\n");

for i in [1..Size(hom1)] do
   for j in [1..Size(hom2)] do
      for k in [1..Size(auto)] do
         for l in [1..Size(auto)] do

#### July 24, 2014 in Yichang, China ######
#### Wieslaw and Leaf add Q, SymQ, SymH, SymK into the list #############

         Add(list,	[[subg, hom1[i]*auto[k]],
                     		[subh, hom2[j]*auto[l]],
			quo, QSymbol( IdSmallGroup(quo) ),
			HSymbol(G, subg),
			HSymbol(H, subh), 
                     		]);
#
#		Print("\n i = ", i, " j = ", j, "\n");
#
#
#		hom11 :=  hom1[i]*auto[k];
##		hom22 := hom2[j]*auto[l];
#		h1   := subg;	
#		h2   := subh;	
##						
#		k1   := Image( hom11, h1 );
#		k2   := Image( hom22, h2 );
#		
#
#		Generator_List := [];
#
#		for element1 in k1 do
##			for element2 in k2 do
#
#Print( "\nEnd here ... \n");
#
#				if i > 1 then
##
#					if Image( hom11, element1 ) = Image( hom22, element2 ) then
#						Add( Generator_List, element1 * element2 );
#					fi;
#
#				fi;
#			od;
#		od;
#
#




         od;
      od;
   od;  
od;

return list;

end;

############# Equivalence Relation #################

Equ_Rel:=function(g, tup1, h, tup2)

local subg, subh, norsubg, norsubh, q,
      homsubg1, homsubh1, homsubg2, homsubh2, auto,
      flag, m,
      i, j, k;

subg:=tup1[1][1];
subh:=tup1[2][1];
norsubg:=List(Normalizer(g, subg));
norsubh:=List(Normalizer(h, subh));
subg:=List(subg);
subh:=List(subh);
homsubg1:=tup1[1][2];
homsubh1:=tup1[2][2];
homsubg2:=tup2[1][2];
homsubh2:=tup2[2][2];
q:=Image(homsubg1);
auto:=List(AutomorphismGroup(q));


flag:="false";
m:=1;
while m<=Size(auto) and flag="false" do



i:=1;
   while i<=Size(norsubg) do
	j:=1;
		while j<=Size(subg) do
			if Image(homsubg1, subg[j])
				=Image(homsubg2*auto[m], subg[j]^norsubg[i]) then
				j:=j+1;
			else break;
			fi;
		od;

		if j=Size(subg)+1 then
			flag:="ture";
			break;
		elif i=Size(norsubg) then
			flag:="false";
			break;
		else i:=i+1;
		fi;
	od;


if flag="ture" then
i:=1;
   while i<=Size(norsubh) do
	j:=1;
		while j<=Size(subh) do
			if Image(homsubh1, subh[j])
				=Image(homsubh2*auto[m], subh[j]^norsubh[i]) then
				j:=j+1;
			else break;
			fi;
      od;

		if j=Size(subh)+1 then
			flag:="ture";
			break;
		elif i=Size(norsubh) then
			flag:="false";
			break;
		else i:=i+1;
		fi;
	od;
fi;



m:=m+1;
od;

return(flag);

end;

############## Delete Equivalent Homomorphism ################

Del_Equ:=function(G, subg, H, subh, quo)

local tup,
      i, j;

#tup:= Gen_Tup(subg, subh, quo);

# updated by Leaf on Thursday, July 24th, 2014 in Yichang, Hubei, China
tup:= Gen_Tup(G, subg, H, subh, quo);


i:=Size(tup);
while i>0 do
   for j in [1..i-1] do
      if Equ_Rel(G.group, tup[i], H.group, tup[j])="ture" then
         Remove(tup, i);
         break;
      fi;
   od;
   i:=i-1;
od;

return (tup);

end;

############## Generate Subgroup list #########################

Subgroup_List:=function(g, quo)

local ccs, q, list,
      i;

ccs:=ConjugacyClassesSubgroups(g);
#q:=SmallGroup(quo);
list:=[];

for i in [1..Size(ccs)] do
#   if GQuotients(ccs[i][1], q)<>[] then
   if GQuotients(ccs[i][1], quo)<>[] then
      Add(list, ccs[i][1]);
   fi;
od;

return list;

end;

######### Amalgamated Product ###################

Ama_Pro:=function(G, H, quo)

local subg, subh, ama,
      i, j, k;

subg:=Subgroup_List(G.group, quo);
subh:=Subgroup_List(H.group, quo);
ama:=[];

for i in [1..Size(subg)] do
   for j in [1..Size(subh)] do
      Add(ama, Del_Equ(G, subg[i], H, subh[j], quo));
   od;
od;

return ama;

end;
      


############ Sum of Ama ###################


Sum_Ama:=function(ama)

local 
	sum, 
	i, j, k;

	sum:=0;

	for i in [1..Size(ama)] do
	for j in [1..Size(ama[i])] do
   		sum := sum + Size( ama[i][j] );
	od;
	od;

	return sum;

end;
   


############ Simple List ###################

Ama_Sim:= function (g, h, quo)

local ama, tem, list,
      i, j;

ama:=Ama_Pro(g, h, quo);
list:=[];

for i in [1..Size(ama)] do
   for j in [1..Size(ama[i])] do
      tem:=Flat(ama[i][j]);
      Add(list, tem);
   od;
od;

return list;
end;




